/* crtolf - convert \r to \n */

/* This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Copyright (C) 2006 Erik Auerswald
 * auerswal@unix-ag.uni-kl.de */

#define VERSION "1.0.0"
#define PROGNAME "crtolf"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char **argv)
{
  int c;
  int ret = 0;

  /* print version and short help and exit if command line parameters are
     present */
  if(argc != 1) {
    printf(PROGNAME " version " VERSION "\n");
    printf("copyright (C) 2006 Erik Auerswald <auerswal@unix-ag.uni-kl.de>\n");
    printf("distributed under the GPL v2 or later\n");

    if(!strncmp(argv[1], "-V", 2) || !strncmp(argv[1], "--v", 3))
      exit(EXIT_SUCCESS);

    printf("\nusage: " PROGNAME "\n");
    printf("       " PROGNAME " -h | --help | -V | --version\n\n");
    printf("reads from stdin, writes to stdout\n");
    printf("converts \\r to \\n\n");

    if(!strncmp(argv[1], "-h", 2) || !strncmp(argv[1], "--h", 3))
      exit(EXIT_SUCCESS);
    else
      exit(EXIT_FAILURE);
  }

  for(c = fgetc(stdin); c != EOF; c = fgetc(stdin)) {

    /* convert \r to \n */
    if(c == '\r') {
      ret = fputc('\n', stdout);
      fflush(stdout);
    } else {
      ret = fputc(c, stdout);
    }

    /* abort on error */
    if(ret == EOF) {
      perror(PROGNAME ": error writing to stdout");
      exit(EXIT_FAILURE);
    }
  }

  exit(EXIT_SUCCESS);
}
